/* A Bison parser, made by GNU Bison 2.7.12-4996.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.12-4996"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         Mawk_parse
#define yylex           Mawk_lex
#define yyerror         Mawk_error
#define yylval          Mawk_lval
#define yychar          Mawk_char
#define yydebug         Mawk_debug
#define yynerrs         Mawk_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 86 "parse.y"

#include <stdio.h>
#include "mawk.h"
#include "types.h"
#include "symtype.h"
#include "code.h"
#include "memory.h"
#include "bi_funct.h"
#include "bi_vars.h"
#include "jmp.h"
#include "field.h"
#include "files.h"
#include "scan.h"
#include "zmalloc.h"


#define  YYMAXDEPTH	200

void mawk_eat_nl(mawk_state_t * MAWK, YYSTYPE *lvalp);
static void  resize_fblock(mawk_state_t *, FBLOCK *);
static void  switch_code_to_main(mawk_state_t *);
static void  mawk_code_array(mawk_state_t *, SYMTAB *);
static void  mawk_code_call_id(mawk_state_t *, CA_REC *, SYMTAB *);
static void  field_A2I(mawk_state_t *MAWK);
static void  check_var(mawk_state_t *, SYMTAB *);
static void  check_array(mawk_state_t *, SYMTAB *);
static void  RE_as_arg(mawk_state_t *MAWK);

void mawk_parser_include(mawk_state_t *MAWK, void *str);

#define  mawk_code_address(x) \
do { \
	if (is_local(x)) \
		mawk_code2op(MAWK, L_PUSHA, (x)->offset) ;\
	else \
		code2(MAWK, _PUSHA, (x)->stval.cp); \
} while(0)

#define  CDP(x)  (mawk_code_base+(x))
/* WARNING: These CDP() calculations become invalid after calls
   that might change code_base.  Which are:  code2(), mawk_code2op(),
   code_jmp() and code_pop().
*/

/* this nonsense caters to MSDOS large model */
#define  CODE_FE_PUSHA()  mawk_code_ptr->ptr = (PTR) 0 ; code1(FE_PUSHA)


/* Line 371 of yacc.c  */
#line 124 "y.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_MAWK_Y_TAB_H_INCLUDED
# define YY_MAWK_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int Mawk_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     UNEXPECTED = 258,
     BAD_DECIMAL = 259,
     NL = 260,
     SEMI_COLON = 261,
     LBRACE = 262,
     RBRACE = 263,
     LBOX = 264,
     RBOX = 265,
     COMMA = 266,
     IO_OUT = 267,
     POW_ASG = 268,
     MOD_ASG = 269,
     DIV_ASG = 270,
     MUL_ASG = 271,
     SUB_ASG = 272,
     ADD_ASG = 273,
     ASSIGN = 274,
     COLON = 275,
     QMARK = 276,
     OR = 277,
     AND = 278,
     IN = 279,
     MATCH = 280,
     GTE = 281,
     GT = 282,
     LTE = 283,
     LT = 284,
     NEQ = 285,
     EQ = 286,
     CAT = 287,
     GETLINE = 288,
     MINUS = 289,
     PLUS = 290,
     MOD = 291,
     DIV = 292,
     MUL = 293,
     UMINUS = 294,
     NOT = 295,
     PIPE = 296,
     IO_IN = 297,
     POW = 298,
     INC_or_DEC = 299,
     FIELD = 300,
     DOLLAR = 301,
     RPAREN = 302,
     LPAREN = 303,
     DOUBLE = 304,
     STRING_ = 305,
     RE = 306,
     ID = 307,
     D_ID = 308,
     FUNCT_ID = 309,
     C_FUNCT_ID = 310,
     BUILTIN = 311,
     LENGTH = 312,
     PRINT = 313,
     PRINTF = 314,
     SPLIT = 315,
     MATCH_FUNC = 316,
     SUB = 317,
     GSUB = 318,
     DO = 319,
     WHILE = 320,
     FOR = 321,
     BREAK = 322,
     CONTINUE = 323,
     IF = 324,
     ELSE = 325,
     DELETE = 326,
     BEGIN = 327,
     END = 328,
     EXIT = 329,
     NEXT = 330,
     RETURN = 331,
     FUNCTION = 332,
     INCLUDE = 333
   };
#endif
/* Tokens.  */
#define UNEXPECTED 258
#define BAD_DECIMAL 259
#define NL 260
#define SEMI_COLON 261
#define LBRACE 262
#define RBRACE 263
#define LBOX 264
#define RBOX 265
#define COMMA 266
#define IO_OUT 267
#define POW_ASG 268
#define MOD_ASG 269
#define DIV_ASG 270
#define MUL_ASG 271
#define SUB_ASG 272
#define ADD_ASG 273
#define ASSIGN 274
#define COLON 275
#define QMARK 276
#define OR 277
#define AND 278
#define IN 279
#define MATCH 280
#define GTE 281
#define GT 282
#define LTE 283
#define LT 284
#define NEQ 285
#define EQ 286
#define CAT 287
#define GETLINE 288
#define MINUS 289
#define PLUS 290
#define MOD 291
#define DIV 292
#define MUL 293
#define UMINUS 294
#define NOT 295
#define PIPE 296
#define IO_IN 297
#define POW 298
#define INC_or_DEC 299
#define FIELD 300
#define DOLLAR 301
#define RPAREN 302
#define LPAREN 303
#define DOUBLE 304
#define STRING_ 305
#define RE 306
#define ID 307
#define D_ID 308
#define FUNCT_ID 309
#define C_FUNCT_ID 310
#define BUILTIN 311
#define LENGTH 312
#define PRINT 313
#define PRINTF 314
#define SPLIT 315
#define MATCH_FUNC 316
#define SUB 317
#define GSUB 318
#define DO 319
#define WHILE 320
#define FOR 321
#define BREAK 322
#define CONTINUE 323
#define IF 324
#define ELSE 325
#define DELETE 326
#define BEGIN 327
#define END 328
#define EXIT 329
#define NEXT 330
#define RETURN 331
#define FUNCTION 332
#define INCLUDE 333



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 135 "parse.y"

mawk_cell_t *cp ;
SYMTAB *stp ;
int  start ; /* code starting address as offset from code_base */
PF_CP  fp ;  /* ptr to a (print/printf) or (sub/gsub) function */
const BI_REC *bip ; /* ptr to info about a builtin */
FBLOCK  *fbp  ; /* ptr to a function block */
ARG2_REC *arg2p ;
CA_REC   *ca_p  ;
int   ival ;
PTR   ptr ;


/* Line 387 of yacc.c  */
#line 337 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int Mawk_parse (void *YYPARSE_PARAM);
#else
int Mawk_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int Mawk_parse (mawk_state_t *MAWK);
#else
int Mawk_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_MAWK_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 364 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  102
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1175

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  60
/* YYNRULES -- Number of rules.  */
#define YYNRULES  185
/* YYNRULES -- Number of states.  */
#define YYNSTATES  360

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    15,    17,    19,
      20,    24,    25,    29,    30,    34,    35,    36,    43,    47,
      51,    53,    55,    57,    60,    62,    65,    67,    70,    73,
      76,    78,    81,    83,    85,    87,    91,    95,    99,   103,
     107,   111,   115,   119,   123,   127,   131,   135,   139,   143,
     147,   151,   155,   159,   163,   167,   171,   172,   177,   178,
     183,   184,   185,   193,   195,   198,   200,   202,   204,   208,
     210,   214,   218,   222,   226,   230,   234,   237,   240,   243,
     245,   248,   251,   254,   257,   260,   262,   263,   265,   267,
     271,   277,   279,   280,   286,   288,   290,   292,   296,   299,
     303,   307,   308,   311,   316,   319,   321,   326,   328,   336,
     341,   344,   349,   353,   358,   360,   363,   365,   368,   372,
     378,   384,   390,   396,   403,   411,   415,   422,   425,   427,
     430,   437,   440,   444,   446,   450,   454,   458,   462,   466,
     470,   474,   477,   483,   485,   489,   496,   498,   501,   505,
     508,   512,   514,   517,   520,   524,   529,   531,   533,   535,
     537,   540,   544,   551,   553,   555,   557,   561,   564,   569,
     572,   575,   576,   578,   580,   584,   586,   590,   594,   597,
     600,   602,   606,   610,   613,   616
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      80,     0,    -1,    81,    -1,    80,    81,    -1,    82,    -1,
     129,    -1,   134,    88,    -1,    88,    -1,   138,    -1,    -1,
      72,    83,    88,    -1,    -1,    73,    84,    88,    -1,    -1,
      93,    85,    89,    -1,    -1,    -1,    93,    11,    86,    93,
      87,    89,    -1,     7,    90,     8,    -1,     7,     1,     8,
      -1,    88,    -1,    92,    -1,    91,    -1,    90,    91,    -1,
      88,    -1,    93,    92,    -1,    92,    -1,     1,    92,    -1,
      67,    92,    -1,    68,    92,    -1,   123,    -1,    75,    92,
      -1,     5,    -1,     6,    -1,    98,    -1,   100,    19,    93,
      -1,   100,    18,    93,    -1,   100,    17,    93,    -1,   100,
      16,    93,    -1,   100,    15,    93,    -1,   100,    14,    93,
      -1,   100,    13,    93,    -1,   117,    19,    93,    -1,   117,
      18,    93,    -1,   117,    17,    93,    -1,   117,    16,    93,
      -1,   117,    15,    93,    -1,   117,    14,    93,    -1,   117,
      13,    93,    -1,    93,    31,    93,    -1,    93,    30,    93,
      -1,    93,    29,    93,    -1,    93,    28,    93,    -1,    93,
      27,    93,    -1,    93,    26,    93,    -1,    93,    25,    93,
      -1,    -1,    93,    22,    94,    93,    -1,    -1,    93,    23,
      95,    93,    -1,    -1,    -1,    93,    21,    96,    93,    20,
      97,    93,    -1,    99,    -1,    98,    99,    -1,    49,    -1,
      50,    -1,    52,    -1,    48,    93,    47,    -1,    51,    -1,
      99,    35,    99,    -1,    99,    34,    99,    -1,    99,    38,
      99,    -1,    99,    37,    99,    -1,    99,    36,    99,    -1,
      99,    43,    99,    -1,    40,    99,    -1,    35,    99,    -1,
      34,    99,    -1,   103,    -1,    52,    44,    -1,    44,   100,
      -1,    44,   117,    -1,   119,    44,    -1,    44,   119,    -1,
      52,    -1,    -1,   102,    -1,    93,    -1,   102,    11,    93,
      -1,    56,   104,    48,   101,    47,    -1,    57,    -1,    -1,
     105,   104,   106,   108,    92,    -1,    58,    -1,    59,    -1,
     101,    -1,    48,   107,    47,    -1,    48,    47,    -1,    93,
      11,    93,    -1,   107,    11,    93,    -1,    -1,    12,    93,
      -1,    69,    48,    93,    47,    -1,   109,    91,    -1,    70,
      -1,   109,    91,   110,    91,    -1,    64,    -1,   111,    91,
      65,    48,    93,    47,    92,    -1,    65,    48,    93,    47,
      -1,   112,    91,    -1,   113,   114,   115,    91,    -1,    66,
      48,     6,    -1,    66,    48,    93,     6,    -1,     6,    -1,
      93,     6,    -1,    47,    -1,    93,    47,    -1,    93,    24,
      52,    -1,    48,   107,    47,    24,    52,    -1,    52,   104,
       9,   102,    10,    -1,    52,   104,     9,   102,    10,    -1,
      52,   104,     9,   102,    10,    -1,    52,   104,     9,   102,
      10,    44,    -1,    71,    52,   104,     9,   102,    10,    92,
      -1,    71,    52,    92,    -1,    66,    48,    52,    24,    52,
      47,    -1,   118,    91,    -1,    45,    -1,    46,    53,    -1,
      46,    53,   104,     9,   102,    10,    -1,    46,    99,    -1,
      48,   119,    47,    -1,   119,    -1,   119,    19,    93,    -1,
     119,    18,    93,    -1,   119,    17,    93,    -1,   119,    16,
      93,    -1,   119,    15,    93,    -1,   119,    14,    93,    -1,
     119,    13,    93,    -1,   120,   121,    -1,    60,    48,    93,
      11,    52,    -1,    47,    -1,    11,    93,    47,    -1,    61,
      48,    93,    11,   122,    47,    -1,    93,    -1,    74,    92,
      -1,    74,    93,    92,    -1,    76,    92,    -1,    76,    93,
      92,    -1,   124,    -1,   124,   125,    -1,   126,    99,    -1,
      99,    41,    33,    -1,    99,    41,    33,   125,    -1,    33,
      -1,   100,    -1,   116,    -1,   119,    -1,   124,    42,    -1,
     124,   125,    42,    -1,   127,    48,   122,    11,    93,   128,
      -1,    62,    -1,    63,    -1,    47,    -1,    11,   125,    47,
      -1,   130,    88,    -1,   131,    48,   132,    47,    -1,    77,
      52,    -1,    77,    54,    -1,    -1,   133,    -1,    52,    -1,
     133,    11,    52,    -1,     1,    -1,    54,   104,   135,    -1,
      55,   104,   135,    -1,    48,    47,    -1,   136,   137,    -1,
      48,    -1,   136,    93,    11,    -1,   136,    52,    11,    -1,
      93,    47,    -1,    52,    47,    -1,    78,    50,     5,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   212,   212,   213,   216,   217,   218,   221,   226,   229,
     228,   235,   234,   241,   240,   248,   264,   247,   277,   279,
     285,   286,   292,   293,   297,   298,   300,   302,   308,   311,
     314,   318,   326,   326,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   351,   380,   379,   387,   386,
     393,   394,   393,   399,   400,   404,   406,   408,   416,   420,
     424,   425,   426,   427,   428,   429,   430,   432,   434,   436,
     439,   447,   452,   459,   463,   470,   479,   480,   483,   485,
     490,   501,   511,   514,   523,   524,   527,   528,   532,   536,
     541,   545,   546,   553,   558,   562,   566,   574,   579,   585,
     605,   631,   655,   656,   660,   661,   678,   682,   695,   700,
     713,   726,   739,   751,   768,   776,   787,   801,   818,   820,
     829,   843,   845,   849,   853,   854,   855,   856,   857,   858,
     859,   865,   869,   876,   878,   902,   909,   932,   935,   938,
     941,   946,   953,   959,   964,   969,   976,   980,   980,   980,
     982,   986,   994,  1013,  1014,  1018,  1023,  1031,  1039,  1058,
    1081,  1088,  1089,  1092,  1098,  1111,  1123,  1135,  1144,  1146,
    1161,  1163,  1170,  1179,  1185,  1193
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "UNEXPECTED", "BAD_DECIMAL", "NL",
  "SEMI_COLON", "LBRACE", "RBRACE", "LBOX", "RBOX", "COMMA", "IO_OUT",
  "POW_ASG", "MOD_ASG", "DIV_ASG", "MUL_ASG", "SUB_ASG", "ADD_ASG",
  "ASSIGN", "COLON", "QMARK", "OR", "AND", "IN", "MATCH", "GTE", "GT",
  "LTE", "LT", "NEQ", "EQ", "CAT", "GETLINE", "MINUS", "PLUS", "MOD",
  "DIV", "MUL", "UMINUS", "NOT", "PIPE", "IO_IN", "POW", "INC_or_DEC",
  "FIELD", "DOLLAR", "RPAREN", "LPAREN", "DOUBLE", "STRING_", "RE", "ID",
  "D_ID", "FUNCT_ID", "C_FUNCT_ID", "BUILTIN", "LENGTH", "PRINT", "PRINTF",
  "SPLIT", "MATCH_FUNC", "SUB", "GSUB", "DO", "WHILE", "FOR", "BREAK",
  "CONTINUE", "IF", "ELSE", "DELETE", "BEGIN", "END", "EXIT", "NEXT",
  "RETURN", "FUNCTION", "INCLUDE", "$accept", "program", "program_block",
  "PA_block", "$@1", "$@2", "$@3", "$@4", "$@5", "block",
  "block_or_separator", "statement_list", "statement", "separator", "expr",
  "$@6", "$@7", "$@8", "$@9", "cat_expr", "p_expr", "lvalue", "arglist",
  "args", "builtin", "mark", "print", "pr_args", "arg2", "pr_direction",
  "if_front", "else", "do", "while_front", "for1", "for2", "for3",
  "bifunct_target_arr", "lvalue_arrwr", "array_loop_front", "field",
  "split_front", "split_back", "re_arg", "return_statement", "getline",
  "bifunct_target", "getline_file", "sub_or_gsub", "sub_back",
  "function_def", "funct_start", "funct_head", "f_arglist", "f_args",
  "outside_error", "call_args", "ca_front", "ca_back", "include", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    79,    80,    80,    81,    81,    81,    82,    82,    83,
      82,    84,    82,    85,    82,    86,    87,    82,    88,    88,
      89,    89,    90,    90,    91,    91,    91,    91,    91,    91,
      91,    91,    92,    92,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    94,    93,    95,    93,
      96,    97,    93,    98,    98,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,   100,   101,   101,   102,   102,
     103,   103,   104,    91,   105,   105,   106,   106,   106,   107,
     107,   108,   108,   109,    91,   110,    91,   111,    91,   112,
      91,    91,   113,   113,   114,   114,   115,   115,    93,    93,
     116,   117,    99,    99,    91,    91,   118,    91,   119,   119,
     119,   119,   119,    99,    93,    93,    93,    93,    93,    93,
      93,    99,   120,   121,   121,    99,   122,    91,    91,   123,
     123,    99,    99,    99,    99,    99,   124,   125,   125,   125,
     126,   126,    99,   127,   127,   128,   128,   129,   130,   131,
     131,   132,   132,   133,   133,   134,    99,    99,   135,   135,
     136,   136,   136,   137,   137,   138
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     0,
       3,     0,     3,     0,     3,     0,     0,     6,     3,     3,
       1,     1,     1,     2,     1,     2,     1,     2,     2,     2,
       1,     2,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     0,     4,     0,     4,
       0,     0,     7,     1,     2,     1,     1,     1,     3,     1,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     1,
       2,     2,     2,     2,     2,     1,     0,     1,     1,     3,
       5,     1,     0,     5,     1,     1,     1,     3,     2,     3,
       3,     0,     2,     4,     2,     1,     4,     1,     7,     4,
       2,     4,     3,     4,     1,     2,     1,     2,     3,     5,
       5,     5,     5,     6,     7,     3,     6,     2,     1,     2,
       6,     2,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     2,     5,     1,     3,     6,     1,     2,     3,     2,
       3,     1,     2,     2,     3,     4,     1,     1,     1,     1,
       2,     3,     6,     1,     1,     1,     3,     2,     4,     2,
       2,     0,     1,     1,     3,     1,     3,     3,     2,     2,
       1,     3,     3,     2,     2,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   175,     0,   156,     0,     0,     0,     0,   128,     0,
       0,    65,    66,    69,    67,    92,    92,    92,    91,     0,
       0,   163,   164,     9,    11,     0,     0,     0,     2,     4,
       7,    13,    34,    63,     0,    79,     0,   133,     0,   151,
       0,     0,     5,     0,     0,     0,     8,     0,    32,    33,
      94,    95,   107,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    24,     0,    22,    26,     0,    92,     0,     0,
       0,     0,     0,    30,     0,    67,    78,   133,    77,    76,
       0,    85,    81,    82,    84,   129,   131,     0,     0,   133,
      80,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     170,     0,     1,     3,    15,    60,    56,    58,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,   143,   141,
     160,    85,   157,   158,   159,   152,   153,     0,   167,   171,
       6,    19,    27,     0,     0,    28,    29,     0,    92,   147,
       0,    31,   149,     0,     0,    18,    23,    25,    86,   104,
       0,   110,   114,     0,     0,   127,     0,     0,     0,     0,
       0,     0,    68,     0,     0,   132,     0,   180,   176,     0,
     177,    86,     0,     0,    10,    12,   185,     0,     0,     0,
       0,   118,    55,    54,    53,    52,    51,    50,    49,    20,
      14,    21,    71,    70,    74,    73,    72,   154,    75,    41,
      40,    39,    38,    37,    36,    35,    48,    47,    46,    45,
      44,    43,    42,   140,   139,   138,   137,   136,   135,   134,
       0,     0,   161,   146,     0,   173,     0,   172,     0,   112,
      67,     0,     0,   125,     0,   148,   150,     0,    88,    96,
      87,   101,   105,     0,     0,   115,   116,     0,     0,     0,
       0,     0,    99,   100,     0,     0,   178,    67,     0,   179,
       0,     0,     0,    16,     0,    57,    59,   155,   144,     0,
       0,   168,     0,   109,     0,   113,   103,     0,    98,     0,
       0,     0,     0,   106,     0,   117,   111,     0,     0,     0,
     119,   122,   182,   184,   181,   183,    90,   142,     0,     0,
      61,     0,     0,   174,     0,     0,    97,    89,   102,    93,
       0,   122,   121,   130,   123,   145,    17,     0,   120,     0,
     165,   162,   126,     0,     0,    62,     0,   124,   108,   166
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    27,    28,    29,    97,    98,   116,   207,   329,    62,
     220,    63,    64,    65,    66,   209,   210,   208,   347,    32,
      33,    34,   269,   270,    35,    91,    67,   271,    88,   312,
      68,   273,    69,    70,    71,   184,   278,   153,    36,    72,
      37,    38,   149,   254,    73,    39,   155,    40,    41,   351,
      42,    43,    44,   256,   257,    45,   198,   199,   289,    46
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -226
static const yytype_int16 yypact[] =
{
     351,  -226,   505,  -226,   799,   799,   799,   -11,  -226,   706,
     830,  -226,  -226,  -226,   442,  -226,  -226,  -226,  -226,   -37,
     -33,  -226,  -226,  -226,  -226,    -9,   -22,   316,  -226,  -226,
    -226,  1102,   799,   922,  1029,  -226,  1067,    49,     6,   -16,
     799,    -8,  -226,    62,    24,    62,  -226,   153,  -226,  -226,
    -226,  -226,  -226,    42,    68,    18,    18,    74,    94,   200,
      18,   200,  -226,   433,  -226,  -226,   945,  -226,   577,   577,
     577,   624,   577,  -226,   830,    16,   119,   125,   119,   119,
      37,   147,  -226,  -226,  -226,   147,  -226,   494,    10,   402,
    -226,   166,   131,   131,   138,   830,   830,    62,    62,  -226,
    -226,   197,  -226,  -226,  -226,  -226,  -226,  -226,   151,   830,
     830,   830,   830,   830,   830,   830,   183,   922,   799,   799,
     799,   799,   799,   171,   799,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,  -226,   830,  -226,  -226,
    -226,   147,  -226,  -226,  -226,   172,   142,   830,  -226,   163,
    -226,  -226,  -226,   830,   655,  -226,  -226,   830,    18,  -226,
     945,  -226,  -226,   945,    18,  -226,  -226,  -226,   861,   148,
     154,  -226,  -226,  1070,   737,  -226,   956,   211,   176,   215,
     216,   830,  -226,   830,   212,  -226,   830,   191,  -226,   892,
    -226,   830,  1123,  1144,  -226,  -226,  -226,   830,   830,   830,
     830,  -226,   201,  -226,  -226,  -226,  -226,  -226,  -226,  -226,
    -226,  -226,   112,   112,   119,   119,   119,    46,   198,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     967,   233,  -226,   578,   232,  -226,   206,   247,   994,  -226,
     259,  1081,  1005,  -226,   250,  -226,  -226,   768,   578,  -226,
     253,   257,  -226,   577,   217,  -226,  -226,  1032,   577,   830,
     830,   830,   578,   578,   218,    45,  -226,    33,   566,  -226,
     224,   230,   830,   578,   506,    77,   980,  -226,  -226,   830,
     830,  -226,   234,  -226,   235,  -226,  -226,   830,  -226,    11,
     830,   830,    18,  -226,   830,  -226,  -226,    65,    76,   155,
    -226,   319,  -226,  -226,  -226,  -226,  -226,  -226,   237,   183,
    -226,   184,   702,  -226,   238,   187,   212,   578,   578,  -226,
    1043,   244,  -226,  -226,  -226,  -226,  -226,   830,  -226,    46,
    -226,  -226,  -226,    18,    18,   578,   243,  -226,  -226,  -226
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -226,  -226,   266,  -226,  -226,  -226,  -226,  -226,  -226,    54,
     -32,  -226,   -56,   121,     0,  -226,  -226,  -226,  -226,  -226,
     207,    -6,    95,  -107,  -226,     3,  -226,  -226,    31,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,  -226,  -226,   294,  -226,
      -1,  -226,  -226,    12,  -226,  -226,  -225,  -226,  -226,  -226,
    -226,  -226,  -226,  -226,  -226,  -226,   209,  -226,  -226,  -226
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -122
static const yytype_int16 yytable[] =
{
      31,    82,   297,    77,    77,    77,    84,   176,    77,    89,
      87,    95,   179,   180,   181,    96,   185,   147,    92,    93,
      94,   193,   193,    48,    49,   -92,   150,    31,   101,     8,
       9,    77,    80,   152,     8,     9,   151,    80,   154,    77,
     157,    81,   -92,    99,   322,   100,   -85,   -85,   -85,   -85,
     -85,   -85,   -85,   148,    30,   321,   310,   194,   336,   170,
      90,   173,   139,   140,   141,   142,   143,   144,   145,     2,
     178,   183,   159,    89,   186,   341,   310,    90,   187,   188,
     323,    30,     8,     9,   189,    80,   342,   310,   190,   285,
     163,     8,     9,   146,    80,   202,   203,   158,   151,   160,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   212,
     213,   214,   215,   216,   217,   218,   164,    77,    77,    77,
      77,    77,   167,    77,   356,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   168,   250,   120,   121,
     122,   204,   205,   123,   251,   124,   -92,   253,    48,    49,
     123,   161,   124,   258,   261,   343,   310,   262,   162,   146,
     219,   264,   317,   318,   319,   196,   165,   166,   268,   197,
     169,   171,   172,  -122,   277,   124,   201,   177,    48,    49,
       2,   282,   331,   283,   348,   310,   268,   353,   310,   288,
     335,   268,   206,   211,   227,    48,    49,   293,   294,   295,
     296,    76,    78,    79,   252,   255,    86,   313,   272,   274,
     279,   152,   316,   195,   280,   281,   154,   110,   111,   112,
     113,   114,   115,     3,     4,     5,   284,   221,   286,   117,
       6,   124,   299,   300,     7,     8,     9,   156,    10,    11,
      12,    13,    14,   301,    15,    16,    17,    18,   302,   307,
      19,    20,    21,    22,   310,   314,    89,    87,   -92,   311,
     320,   326,   -85,   -85,   -85,   -85,   -85,   -85,   -85,   268,
     268,   268,   327,   304,   345,   352,   333,   334,   344,   263,
     359,   265,   253,   103,   266,   162,   290,   346,   309,   268,
     332,    83,   200,    90,   328,     0,     0,   268,     0,     0,
     337,   338,     0,     0,   340,     0,   102,     1,     0,     0,
       0,     0,     0,     2,     0,   222,   223,   224,   225,   226,
       0,   228,  -121,  -121,  -121,  -121,  -121,  -121,  -121,     0,
       0,     0,     0,   152,     0,     0,     0,   355,   154,     3,
       4,     5,     1,     0,     0,     0,     6,     0,     2,     0,
       7,     8,     9,   344,    10,    11,    12,    13,    14,     0,
      15,    16,    17,    18,     0,     0,    19,    20,    21,    22,
       0,     0,     0,   219,     3,     4,     5,     0,    23,    24,
       0,     6,     0,    25,    26,     7,     8,     9,     0,    10,
      11,    12,    13,    14,     0,    15,    16,    17,    18,     0,
       0,    19,    20,    21,    22,   139,   140,   141,   142,   143,
     144,   145,     0,    23,    24,     0,     0,     0,    25,    26,
       0,     0,     0,   339,   174,     0,     0,     0,    48,    49,
       2,   175,     0,     0,     0,     0,   146,     0,     0,   195,
     221,   -92,     0,     0,     0,   -85,   -85,   -85,   -85,   -85,
     -85,   -85,     0,     0,     0,     0,     3,     4,     5,     0,
       0,     0,     0,     6,   357,   358,     0,     7,     8,     9,
       0,    10,    11,    12,    13,    14,    90,    15,    16,    17,
      18,    50,    51,    19,    20,    21,    22,    52,    53,    54,
      55,    56,    57,     0,    58,   191,    47,    59,    60,    61,
      48,    49,     2,     0,     0,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   330,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     3,     4,
       5,   192,     0,     0,     0,     6,     0,     0,     0,     7,
       8,     9,     0,    10,    11,    12,    13,    14,     0,    15,
      16,    17,    18,    50,    51,    19,    20,    21,    22,    52,
      53,    54,    55,    56,    57,     0,    58,   324,   174,    59,
      60,    61,    48,    49,     2,     0,     0,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       3,     4,     5,   325,     0,     0,     0,     6,     0,     0,
       0,     7,     8,     9,     0,    10,    11,    12,    13,    14,
     182,    15,    16,    17,    18,    50,    51,    19,    20,    21,
      22,    52,    53,    54,    55,    56,    57,     0,    58,     0,
       0,    59,    60,    61,     0,     0,     0,     3,     4,     5,
       0,   259,     0,     0,     6,     0,     0,     0,     7,     8,
       9,     0,    10,    11,    12,    13,    14,     0,    15,    16,
      17,    18,     0,     0,    19,    20,    21,    22,     3,     4,
       5,     0,     0,     0,     0,     6,     0,     0,     0,     7,
       8,     9,     0,    10,    11,    12,    13,   260,     0,    15,
      16,    17,    18,   349,     0,    19,    20,    21,    22,     0,
       0,     0,     0,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,     0,     0,     3,
       4,     5,     0,     0,     0,     0,     6,     0,     0,   350,
       7,     8,     9,     0,    74,    11,    12,    13,    75,    85,
      15,    16,    17,    18,     0,     0,    19,    20,    21,    22,
       3,     4,     5,     0,     0,     0,     0,     6,     0,     0,
       0,     7,     8,     9,   276,    10,    11,    12,    13,    14,
       0,    15,    16,    17,    18,     0,     0,    19,    20,    21,
      22,     3,     4,     5,     0,     0,     0,     0,     6,     0,
       0,     0,     7,     8,     9,   308,    10,    11,    12,    13,
      14,     0,    15,    16,    17,    18,     0,     0,    19,    20,
      21,    22,     3,     4,     5,     0,     0,     0,     0,     6,
       0,     0,     0,     7,     8,     9,     0,    74,    11,    12,
      13,    75,     0,    15,    16,    17,    18,     0,     0,    19,
      20,    21,    22,     3,     4,     5,     0,     0,     0,     0,
       6,     0,     0,     0,     7,     8,     9,     0,    10,    11,
      12,    13,    14,     0,    15,    16,    17,    18,     0,     0,
      19,    20,    21,    22,     3,     4,     5,     0,     0,     0,
       0,     6,     0,     0,     0,     7,     8,     9,     0,   267,
      11,    12,    13,    14,     0,    15,    16,    17,    18,     0,
       0,    19,    20,    21,    22,     3,     4,     5,     0,     0,
       0,     0,     6,     0,     0,     0,     7,     8,     9,     0,
      10,    11,    12,    13,   287,     0,    15,    16,    17,    18,
      48,    49,    19,    20,    21,    22,   118,   119,   120,   121,
     122,     0,     0,   123,     0,   124,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,     0,   192,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,   298,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,     0,     0,     0,
       0,   303,   125,   126,   127,   128,   129,   130,   131,     0,
       0,     0,   306,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,   275,     0,     0,   315,
     132,   133,   134,   135,   136,   137,   138,   305,     0,     0,
     354,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   291,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-226)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-122)))

static const yytype_int16 yycheck[] =
{
       0,     7,   227,     4,     5,     6,     7,    63,     9,    10,
      10,    48,    68,    69,    70,    48,    72,    11,    15,    16,
      17,    11,    11,     5,     6,     9,    42,    27,    50,    45,
      46,    32,    48,    39,    45,    46,    52,    48,    39,    40,
      48,    52,     9,    52,    11,    54,    13,    14,    15,    16,
      17,    18,    19,    47,     0,    10,    11,    47,    47,    59,
      44,    61,    13,    14,    15,    16,    17,    18,    19,     7,
      67,    71,    48,    74,    74,    10,    11,    44,    75,    80,
      47,    27,    45,    46,    81,    48,    10,    11,    85,   196,
      48,    45,    46,    44,    48,    95,    96,    43,    52,    45,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   109,
     110,   111,   112,   113,   114,   115,    48,   118,   119,   120,
     121,   122,    48,   124,   349,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    52,   147,    36,    37,
      38,    97,    98,    41,   151,    43,     9,   157,     5,     6,
      41,     8,    43,   163,   164,    10,    11,   167,    47,    44,
     116,   168,   279,   280,   281,     9,    55,    56,   178,    48,
      59,    60,    61,    41,   184,    43,    48,    66,     5,     6,
       7,   191,   299,   193,    10,    11,   196,    10,    11,   199,
     307,   201,     5,    52,    33,     5,     6,   207,   208,   209,
     210,     4,     5,     6,    42,    52,     9,   273,    70,    65,
       9,   227,   278,    47,     9,     9,   227,    26,    27,    28,
      29,    30,    31,    33,    34,    35,    24,   116,    47,    32,
      40,    43,     9,    11,    44,    45,    46,    40,    48,    49,
      50,    51,    52,    47,    54,    55,    56,    57,    11,     9,
      60,    61,    62,    63,    11,    48,   267,   267,     9,    12,
      52,    47,    13,    14,    15,    16,    17,    18,    19,   279,
     280,   281,    52,    24,    47,    47,    52,    52,    44,   168,
      47,   170,   292,    27,   173,   174,   201,   329,   267,   299,
     300,     7,    93,    44,   292,    -1,    -1,   307,    -1,    -1,
     310,   311,    -1,    -1,   314,    -1,     0,     1,    -1,    -1,
      -1,    -1,    -1,     7,    -1,   118,   119,   120,   121,   122,
      -1,   124,    13,    14,    15,    16,    17,    18,    19,    -1,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   347,   349,    33,
      34,    35,     1,    -1,    -1,    -1,    40,    -1,     7,    -1,
      44,    45,    46,    44,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,   329,    33,    34,    35,    -1,    72,    73,
      -1,    40,    -1,    77,    78,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    13,    14,    15,    16,    17,
      18,    19,    -1,    72,    73,    -1,    -1,    -1,    77,    78,
      -1,    -1,    -1,   312,     1,    -1,    -1,    -1,     5,     6,
       7,     8,    -1,    -1,    -1,    -1,    44,    -1,    -1,    47,
     329,     9,    -1,    -1,    -1,    13,    14,    15,    16,    17,
      18,    19,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,
      -1,    -1,    -1,    40,   353,   354,    -1,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    44,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    11,     1,    74,    75,    76,
       5,     6,     7,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    33,    34,
      35,    47,    -1,    -1,    -1,    40,    -1,    -1,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    11,     1,    74,
      75,    76,     5,     6,     7,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      33,    34,    35,    47,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
       6,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    -1,
      -1,    74,    75,    76,    -1,    -1,    -1,    33,    34,    35,
      -1,     6,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    33,    34,
      35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    11,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    33,
      34,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    47,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      33,    34,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      -1,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    33,    34,    35,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    33,    34,    35,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    33,    34,    35,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    33,    34,    35,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    33,    34,    35,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    56,    57,
       5,     6,    60,    61,    62,    63,    34,    35,    36,    37,
      38,    -1,    -1,    41,    -1,    43,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    47,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    47,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    47,    13,    14,    15,    16,    17,    18,    19,    -1,
      -1,    -1,    47,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,     6,    -1,    -1,    47,
      13,    14,    15,    16,    17,    18,    19,     6,    -1,    -1,
      47,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     7,    33,    34,    35,    40,    44,    45,    46,
      48,    49,    50,    51,    52,    54,    55,    56,    57,    60,
      61,    62,    63,    72,    73,    77,    78,    80,    81,    82,
      88,    93,    98,    99,   100,   103,   117,   119,   120,   124,
     126,   127,   129,   130,   131,   134,   138,     1,     5,     6,
      58,    59,    64,    65,    66,    67,    68,    69,    71,    74,
      75,    76,    88,    90,    91,    92,    93,   105,   109,   111,
     112,   113,   118,   123,    48,    52,    99,   119,    99,    99,
      48,    52,   100,   117,   119,    53,    99,    93,   107,   119,
      44,   104,   104,   104,   104,    48,    48,    83,    84,    52,
      54,    50,     0,    81,    11,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    85,    99,    34,    35,
      36,    37,    38,    41,    43,    13,    14,    15,    16,    17,
      18,    19,    13,    14,    15,    16,    17,    18,    19,    13,
      14,    15,    16,    17,    18,    19,    44,    11,    47,   121,
      42,    52,   100,   116,   119,   125,    99,    48,    88,    48,
      88,     8,    92,    48,    48,    92,    92,    48,    52,    92,
      93,    92,    92,    93,     1,     8,    91,    92,   104,    91,
      91,    91,     6,    93,   114,    91,    93,   104,   119,   104,
     104,    11,    47,    11,    47,    47,     9,    48,   135,   136,
     135,    48,    93,    93,    88,    88,     5,    86,    96,    94,
      95,    52,    93,    93,    93,    93,    93,    93,    93,    88,
      89,    92,    99,    99,    99,    99,    99,    33,    99,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,   104,    42,    93,   122,    52,   132,   133,    93,     6,
      52,    93,    93,    92,   104,    92,    92,    48,    93,   101,
     102,   106,    70,   110,    65,     6,    47,    93,   115,     9,
       9,     9,    93,    93,    24,   102,    47,    52,    93,   137,
     101,    11,    11,    93,    93,    93,    93,   125,    47,     9,
      11,    47,    11,    47,    24,     6,    47,     9,    47,   107,
      11,    12,   108,    91,    48,    47,    91,   102,   102,   102,
      52,    10,    11,    47,    11,    47,    47,    52,   122,    87,
      20,   102,    93,    52,    52,   102,    47,    93,    93,    92,
      93,    10,    10,    10,    44,    47,    89,    97,    10,    11,
      47,   128,    47,    10,    47,    93,   125,    92,    92,    47
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (MAWK, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, MAWK)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, MAWK); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, mawk_state_t *MAWK)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, MAWK)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (MAWK);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, mawk_state_t *MAWK)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, MAWK)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, MAWK);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, mawk_state_t *MAWK)
#else
static void
yy_reduce_print (yyvsp, yyrule, MAWK)
    YYSTYPE *yyvsp;
    int yyrule;
    mawk_state_t *MAWK;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , MAWK);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, MAWK); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, mawk_state_t *MAWK)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, MAWK)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (MAWK);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (mawk_state_t *MAWK)
#else
int
yyparse (MAWK)
    mawk_state_t *MAWK;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
/* Line 1787 of yacc.c  */
#line 222 "parse.y"
    { /* this do nothing action removes a vacuous warning
                  from Bison */
             }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 229 "parse.y"
    { mawk_be_setup(MAWK, MAWK->scope = SCOPE_BEGIN) ; }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 232 "parse.y"
    { switch_code_to_main(MAWK) ; }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 235 "parse.y"
    { mawk_be_setup(MAWK, MAWK->scope = SCOPE_END) ; }
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 238 "parse.y"
    { switch_code_to_main(MAWK) ; }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 241 "parse.y"
    { mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 244 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr ) ; }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 248 "parse.y"
    { 
	       INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
             int len ;

	       mawk_code_push(MAWK, p1, mawk_code_ptr - p1, MAWK->scope, MAWK->active_funct) ;
               mawk_code_ptr = p1 ;

               mawk_code2op(MAWK, _RANGE, 1) ;
               mawk_code_ptr += 3 ;
               len = mawk_code_pop(MAWK, mawk_code_ptr) ;
             mawk_code_ptr += len ;
               code1(_STOP) ;
             p1 = CDP((yyvsp[(1) - (2)].start)) ;
               p1[2].op = mawk_code_ptr - (p1+1) ;
             }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 264 "parse.y"
    { code1(_STOP) ; }
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 267 "parse.y"
    { 
	       INST *p1 = CDP((yyvsp[(1) - (6)].start)) ;
	       
	       p1[3].op = CDP((yyvsp[(6) - (6)].start)) - (p1+1) ;
               p1[4].op = mawk_code_ptr - (p1+1) ;
             }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 278 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 280 "parse.y"
    { (yyval.start) = mawk_code_offset ; /* does nothing won't be mawk_executed */
              MAWK->print_flag = MAWK->getline_flag = MAWK->paren_cnt = 0 ;
              yyerrok ; }
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 287 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                       code1(_PUSHINT) ; code1(0) ;
                       code2(MAWK, _PRINT, mawk_bi_print) ;
                     }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 299 "parse.y"
    { code1(_POP) ; }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 301 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 303 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                MAWK->print_flag = MAWK->getline_flag = 0 ;
                MAWK->paren_cnt = 0 ;
                yyerrok ;
              }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 309 "parse.y"
    { (yyval.start) = mawk_code_offset ; mawk_BC_insert(MAWK, 'B', mawk_code_ptr+1) ;
               code2(MAWK, _JMP, 0) /* don't use mawk_code_jmp ! */ ; }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 312 "parse.y"
    { (yyval.start) = mawk_code_offset ; mawk_BC_insert(MAWK, 'C', mawk_code_ptr+1) ;
               code2(MAWK, _JMP, 0) ; }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 315 "parse.y"
    { if ( MAWK->scope != SCOPE_FUNCT )
                     mawk_compile_error(MAWK, "return outside function body") ;
             }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 319 "parse.y"
    { if ( MAWK->scope != SCOPE_MAIN )
                   mawk_compile_error(MAWK, "improper use of next" ) ;
                (yyval.start) = mawk_code_offset ; 
                code1(_NEXT) ;
              }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 330 "parse.y"
    { code1(_ASSIGN) ; }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 331 "parse.y"
    { code1(_ADD_ASG) ; }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 332 "parse.y"
    { code1(_SUB_ASG) ; }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 333 "parse.y"
    { code1(_MUL_ASG) ; }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 334 "parse.y"
    { code1(_DIV_ASG) ; }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 335 "parse.y"
    { code1(_MOD_ASG) ; }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 336 "parse.y"
    { code1(_POW_ASG) ; }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 337 "parse.y"
    { code1(_ASSIGN_ARR) ; }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 338 "parse.y"
    { code1(_ADD_ASG_ARR) ; }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 339 "parse.y"
    { code1(_SUB_ASG_ARR) ; }
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 340 "parse.y"
    { code1(_MUL_ASG_ARR) ; }
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 341 "parse.y"
    { code1(_DIV_ASG_ARR) ; }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 342 "parse.y"
    { code1(_MOD_ASG_ARR) ; }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 343 "parse.y"
    { code1(_POW_ASG_ARR) ; }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 344 "parse.y"
    { code1(_EQ) ; }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 345 "parse.y"
    { code1(_NEQ) ; }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 346 "parse.y"
    { code1(_LT) ; }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 347 "parse.y"
    { code1(_LTE) ; }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 348 "parse.y"
    { code1(_GT) ; }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 349 "parse.y"
    { code1(_GTE) ; }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 352 "parse.y"
    {
	    INST *p3 = CDP((yyvsp[(3) - (3)].start)) ;

            if ( p3 == mawk_code_ptr - 2 )
            {
               if ( p3->op == _MATCH0 )  p3->op = _MATCH1 ;

               else /* check for string */
               if ( p3->op == _PUSHS )
               {
               	mawk_cell_t *cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;

                 cp->type = C_STRING ;
                 cp->ptr = p3[1].ptr ;
                 mawk_cast_to_RE(MAWK, cp) ;
                 mawk_code_ptr -= 2 ;
                 code2(MAWK, _MATCH1, cp->ptr) ;
                 MAWK_ZFREE(MAWK, cp) ;
               }
               else  code1(_MATCH2) ;
            }
            else code1(_MATCH2) ;

            if ( !(yyvsp[(2) - (3)].ival) ) code1(_NOT) ;
          }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 380 "parse.y"
    { code1(_TEST) ;
                mawk_code_jmp(MAWK, _LJNZ, (INST*)0) ;
              }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 384 "parse.y"
    { code1(_TEST) ; mawk_patch_jmp(MAWK, mawk_code_ptr) ; }
    break;

  case 58:
/* Line 1787 of yacc.c  */
#line 387 "parse.y"
    { code1(_TEST) ; 
		mawk_code_jmp(MAWK, _LJZ, (INST*)0) ;
	      }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 391 "parse.y"
    { code1(_TEST) ; mawk_patch_jmp(MAWK, mawk_code_ptr) ; }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 393 "parse.y"
    { mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 394 "parse.y"
    { mawk_code_jmp(MAWK, _JMP, (INST*)0) ; }
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 396 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr) ; mawk_patch_jmp(MAWK, CDP((yyvsp[(7) - (7)].start))) ; }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 401 "parse.y"
    { code1(_CAT) ; }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 405 "parse.y"
    {  (yyval.start) = mawk_code_offset ; code2(MAWK, _PUSHD, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 66:
/* Line 1787 of yacc.c  */
#line 407 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, _PUSHS, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 67:
/* Line 1787 of yacc.c  */
#line 409 "parse.y"
    { check_var(MAWK, (yyvsp[(1) - (1)].stp)) ;
            (yyval.start) = mawk_code_offset ;
            if ( is_local((yyvsp[(1) - (1)].stp)) )
            { mawk_code2op(MAWK, L_PUSHI, (yyvsp[(1) - (1)].stp)->offset) ; }
            else code2(MAWK, _PUSHI, (yyvsp[(1) - (1)].stp)->stval.cp) ;
          }
    break;

  case 68:
/* Line 1787 of yacc.c  */
#line 417 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 69:
/* Line 1787 of yacc.c  */
#line 421 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, _MATCH0, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 70:
/* Line 1787 of yacc.c  */
#line 424 "parse.y"
    { code1(_ADD) ; }
    break;

  case 71:
/* Line 1787 of yacc.c  */
#line 425 "parse.y"
    { code1(_SUB) ; }
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 426 "parse.y"
    { code1(_MUL) ; }
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 427 "parse.y"
    { code1(_DIV) ; }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 428 "parse.y"
    { code1(_MOD) ; }
    break;

  case 75:
/* Line 1787 of yacc.c  */
#line 429 "parse.y"
    { code1(_POW) ; }
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 431 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_NOT) ; }
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 433 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_UPLUS) ; }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 435 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_UMINUS) ; }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 440 "parse.y"
    { check_var(MAWK, (yyvsp[(1) - (2)].stp)) ;
             (yyval.start) = mawk_code_offset ;
             mawk_code_address((yyvsp[(1) - (2)].stp)) ;

             if ( (yyvsp[(2) - (2)].ival) == '+' )  code1(_POST_INC) ;
             else  code1(_POST_DEC) ;
           }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 448 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; 
              if ( (yyvsp[(1) - (2)].ival) == '+' ) code1(_PRE_INC) ;
              else  code1(_PRE_DEC) ;
            }
    break;

  case 82:
/* Line 1787 of yacc.c  */
#line 453 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; 
              if ( (yyvsp[(1) - (2)].ival) == '+' ) code1(_PRE_INC_ARR) ;
              else  code1(_PRE_DEC_ARR) ;
            }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 460 "parse.y"
    { if ((yyvsp[(2) - (2)].ival) == '+' ) code1(F_POST_INC ) ; 
             else  code1(F_POST_DEC) ;
           }
    break;

  case 84:
/* Line 1787 of yacc.c  */
#line 464 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; 
             if ( (yyvsp[(1) - (2)].ival) == '+' ) code1(F_PRE_INC) ;
             else  code1( F_PRE_DEC) ; 
           }
    break;

  case 85:
/* Line 1787 of yacc.c  */
#line 471 "parse.y"
    { (yyval.start) = mawk_code_offset ; 
          check_var(MAWK, (yyvsp[(1) - (1)].stp)) ;
          mawk_code_address((yyvsp[(1) - (1)].stp)) ;
        }
    break;

  case 86:
/* Line 1787 of yacc.c  */
#line 479 "parse.y"
    { (yyval.ival) = 0 ; }
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 484 "parse.y"
    { (yyval.ival) = 1 ; }
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 486 "parse.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) + 1 ; }
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 491 "parse.y"
    { const BI_REC *p = (yyvsp[(1) - (5)].bip) ;
          (yyval.start) = (yyvsp[(2) - (5)].start) ;
          if ( (int)p->min_args > (yyvsp[(4) - (5)].ival) || (int)p->max_args < (yyvsp[(4) - (5)].ival) )
            mawk_compile_error(
            MAWK, "wrong number of arguments in call to %s" ,
            p->name ) ;
          if ( p->min_args != p->max_args ) /* variable args */
              { code1(_PUSHINT) ;  code1((yyvsp[(4) - (5)].ival)) ; }
          code2(MAWK, _BUILTIN , p->fp) ;
        }
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 502 "parse.y"
    {
	    (yyval.start) = mawk_code_offset ;
	    code1(_PUSHINT) ; code1(0) ;
	    code2(MAWK, _BUILTIN, (yyvsp[(1) - (1)].bip)->fp) ;
	  }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 511 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 515 "parse.y"
    { code2(MAWK, _PRINT, (yyvsp[(1) - (5)].fp)) ; 
              if ( (yyvsp[(1) - (5)].fp) == mawk_bi_printf && (yyvsp[(3) - (5)].ival) == 0 )
                    mawk_compile_error(MAWK, "no arguments in call to printf") ;
              MAWK->print_flag = 0 ;
              (yyval.start) = (yyvsp[(2) - (5)].start) ;
            }
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 523 "parse.y"
    { (yyval.fp) = mawk_bi_print ; MAWK->print_flag = 1 ;}
    break;

  case 95:
/* Line 1787 of yacc.c  */
#line 524 "parse.y"
    { (yyval.fp) = mawk_bi_printf ; MAWK->print_flag = 1 ; }
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 527 "parse.y"
    { mawk_code2op(MAWK, _PUSHINT, (yyvsp[(1) - (1)].ival)) ; }
    break;

  case 97:
/* Line 1787 of yacc.c  */
#line 529 "parse.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].arg2p)->cnt ; mawk_zfree(MAWK, (yyvsp[(2) - (3)].arg2p),sizeof(ARG2_REC)) ; 
             mawk_code2op(MAWK, _PUSHINT, (yyval.ival)) ; 
           }
    break;

  case 98:
/* Line 1787 of yacc.c  */
#line 533 "parse.y"
    { (yyval.ival)=0 ; mawk_code2op(MAWK, _PUSHINT, 0) ; }
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 537 "parse.y"
    { (yyval.arg2p) = (ARG2_REC*) mawk_zmalloc(MAWK, sizeof(ARG2_REC)) ;
             (yyval.arg2p)->start = (yyvsp[(1) - (3)].start) ;
             (yyval.arg2p)->cnt = 2 ;
           }
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 542 "parse.y"
    { (yyval.arg2p) = (yyvsp[(1) - (3)].arg2p) ; (yyval.arg2p)->cnt++ ; }
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 547 "parse.y"
    { mawk_code2op(MAWK, _PUSHINT, (yyvsp[(1) - (2)].ival)) ; }
    break;

  case 103:
/* Line 1787 of yacc.c  */
#line 554 "parse.y"
    {  (yyval.start) = (yyvsp[(3) - (4)].start) ; mawk_eat_nl(MAWK, &yylval) ; mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 104:
/* Line 1787 of yacc.c  */
#line 559 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr ) ;  }
    break;

  case 105:
/* Line 1787 of yacc.c  */
#line 562 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_code_jmp(MAWK, _JMP, (INST*)0) ; }
    break;

  case 106:
/* Line 1787 of yacc.c  */
#line 567 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr) ; 
		  mawk_patch_jmp(MAWK, CDP((yyvsp[(4) - (4)].start))) ; 
		}
    break;

  case 107:
/* Line 1787 of yacc.c  */
#line 575 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ; }
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 580 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (7)].start) ;
          mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(2) - (7)].start))) ; 
          mawk_BC_clear(MAWK, mawk_code_ptr, CDP((yyvsp[(5) - (7)].start))) ; }
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 586 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
                  (yyval.start) = (yyvsp[(3) - (4)].start) ;

                  /* check if const expression */
                  if ( mawk_code_ptr - 2 == CDP((yyvsp[(3) - (4)].start)) &&
                       mawk_code_ptr[-2].op == _PUSHD &&
                       *(double*)mawk_code_ptr[-1].ptr != 0.0 
                     )
                     mawk_code_ptr -= 2 ;
                  else
		  { INST *p3 = CDP((yyvsp[(3) - (4)].start)) ;
		    mawk_code_push(MAWK, p3, mawk_code_ptr-p3, MAWK->scope, MAWK->active_funct) ;
		    mawk_code_ptr = p3 ;
                    code2(MAWK, _JMP, (INST*)0) ; /* code2() not mawk_code_jmp() */
		  }
                }
    break;

  case 110:
/* Line 1787 of yacc.c  */
#line 606 "parse.y"
    { 
		  int  saved_offset ;
		  int len ;
		  INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
		  INST *p2 = CDP((yyvsp[(2) - (2)].start)) ;

                  if ( p1 != p2 )  /* real mawk_test in loop */
		  {
		    p1[1].op = mawk_code_ptr-(p1+1) ;
		    saved_offset = mawk_code_offset ;
		    len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		    mawk_code_ptr += len ;
		    mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(2) - (2)].start))) ;
		    mawk_BC_clear(MAWK, mawk_code_ptr, CDP(saved_offset)) ;
		  }
		  else /* while(1) */
		  {
		    mawk_code_jmp(MAWK, _JMP, p1) ;
		    mawk_BC_clear(MAWK, mawk_code_ptr, CDP((yyvsp[(2) - (2)].start))) ;
		  }
                }
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 632 "parse.y"
    { 
		  int cont_offset = mawk_code_offset ;
                  unsigned len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		  INST *p2 = CDP((yyvsp[(2) - (4)].start)) ;
		  INST *p4 = CDP((yyvsp[(4) - (4)].start)) ;

                  mawk_code_ptr += len ;

		  if ( p2 != p4 )  /* real mawk_test in for2 */
		  {
                    p4[-1].op = mawk_code_ptr - p4 + 1 ;
		    len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		    mawk_code_ptr += len ;
                    mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(4) - (4)].start))) ;
		  }
		  else /*  for(;;) */
		  mawk_code_jmp(MAWK, _JMP, p4) ;

		  mawk_BC_clear(MAWK, mawk_code_ptr, CDP(cont_offset)) ;

                }
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 655 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 657 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (4)].start) ; code1(_POP) ; }
    break;

  case 114:
/* Line 1787 of yacc.c  */
#line 660 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 662 "parse.y"
    { 
             if ( mawk_code_ptr - 2 == CDP((yyvsp[(1) - (2)].start)) &&
                  mawk_code_ptr[-2].op == _PUSHD &&
                  * (double*) mawk_code_ptr[-1].ptr != 0.0
                )
                    mawk_code_ptr -= 2 ;
             else   
	     {
	       INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
	       mawk_code_push(MAWK, p1, mawk_code_ptr-p1, MAWK->scope, MAWK->active_funct) ;
	       mawk_code_ptr = p1 ;
	       code2(MAWK, _JMP, (INST*)0) ;
	     }
           }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 679 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
	     mawk_code_push(MAWK, (INST*)0,0, MAWK->scope, MAWK->active_funct) ;
	   }
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 683 "parse.y"
    { INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;

	     mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ; 
             code1(_POP) ;
             mawk_code_push(MAWK, p1, mawk_code_ptr - p1, MAWK->scope, MAWK->active_funct) ;
             mawk_code_ptr -= mawk_code_ptr - p1 ;
           }
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 696 "parse.y"
    { check_array(MAWK, (yyvsp[(3) - (3)].stp)) ;
             mawk_code_array(MAWK, (yyvsp[(3) - (3)].stp)) ; 
             code1(A_TEST) ; 
            }
    break;

  case 119:
/* Line 1787 of yacc.c  */
#line 701 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (5)].arg2p)->start ;
             mawk_code2op(MAWK, A_CAT, (yyvsp[(2) - (5)].arg2p)->cnt) ;
             mawk_zfree(MAWK, (yyvsp[(2) - (5)].arg2p), sizeof(ARG2_REC)) ;

             check_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
             mawk_code_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
             code1(A_TEST) ;
           }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 714 "parse.y"
    { 
             if ( (yyvsp[(4) - (5)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(4) - (5)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (5)].stp)) ;
             if( is_local((yyvsp[(1) - (5)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHA, (yyvsp[(1) - (5)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHA, (yyvsp[(1) - (5)].stp)->stval.array) ;
             (yyval.start) = (yyvsp[(2) - (5)].start) ;
           }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 727 "parse.y"
    { 
             if ( (yyvsp[(4) - (5)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(4) - (5)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (5)].stp)) ;
             if( is_local((yyvsp[(1) - (5)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHA_WRARR, (yyvsp[(1) - (5)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHA_WRARR, (yyvsp[(1) - (5)].stp)->stval.array) ;
             (yyval.start) = (yyvsp[(2) - (5)].start) ;
           }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 740 "parse.y"
    { 
             if ( (yyvsp[(4) - (5)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(4) - (5)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (5)].stp)) ;
             if( is_local((yyvsp[(1) - (5)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHI, (yyvsp[(1) - (5)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHI, (yyvsp[(1) - (5)].stp)->stval.array) ;
             (yyval.start) = (yyvsp[(2) - (5)].start) ;
           }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 752 "parse.y"
    { 
             if ( (yyvsp[(4) - (6)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT,(yyvsp[(4) - (6)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (6)].stp)) ;
             if( is_local((yyvsp[(1) - (6)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHA_WRARR, (yyvsp[(1) - (6)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHA_WRARR, (yyvsp[(1) - (6)].stp)->stval.array) ;
             if ( (yyvsp[(6) - (6)].ival) == '+' )  code1(_POST_INC_ARR) ;
             else  code1(_POST_DEC_ARR) ;

             (yyval.start) = (yyvsp[(2) - (6)].start) ;
           }
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 769 "parse.y"
    { 
               (yyval.start) = (yyvsp[(3) - (7)].start) ;
               if ( (yyvsp[(5) - (7)].ival) > 1 ) { mawk_code2op(MAWK, A_CAT, (yyvsp[(5) - (7)].ival)) ; }
               check_array(MAWK, (yyvsp[(2) - (7)].stp)) ;
               mawk_code_array(MAWK, (yyvsp[(2) - (7)].stp)) ;
               code1(A_DEL) ;
             }
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 777 "parse.y"
    {
		(yyval.start) = mawk_code_offset ;
		check_array(MAWK, (yyvsp[(2) - (3)].stp)) ;
		mawk_code_array(MAWK, (yyvsp[(2) - (3)].stp)) ;
		code1(DEL_A) ;
	     }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 788 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
                      (yyval.start) = mawk_code_offset ;

                      check_var(MAWK, (yyvsp[(3) - (6)].stp)) ;
                      mawk_code_address((yyvsp[(3) - (6)].stp)) ;
                      check_array(MAWK, (yyvsp[(5) - (6)].stp)) ;
                      mawk_code_array(MAWK, (yyvsp[(5) - (6)].stp)) ;

                      code2(MAWK, SET_ALOOP, (INST*)0) ;
                    }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 802 "parse.y"
    { 
		INST *p2 = CDP((yyvsp[(2) - (2)].start)) ;

	        p2[-1].op = mawk_code_ptr - p2 + 1 ;
                mawk_BC_clear(MAWK, mawk_code_ptr+2 , mawk_code_ptr) ;
		mawk_code_jmp(MAWK, ALOOP, p2) ;
		code1(POP_AL) ;
              }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 819 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, F_PUSHA, (yyvsp[(1) - (1)].cp)) ; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 821 "parse.y"
    { check_var(MAWK, (yyvsp[(2) - (2)].stp)) ;
             (yyval.start) = mawk_code_offset ;
             if ( is_local((yyvsp[(2) - (2)].stp)) )
             { mawk_code2op(MAWK, L_PUSHI, (yyvsp[(2) - (2)].stp)->offset) ; }
             else code2(MAWK, _PUSHI, (yyvsp[(2) - (2)].stp)->stval.cp) ;

	     CODE_FE_PUSHA() ;
           }
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 830 "parse.y"
    { 
             if ( (yyvsp[(5) - (6)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(5) - (6)].ival)) ; }

             check_array(MAWK, (yyvsp[(2) - (6)].stp)) ;
             if( is_local((yyvsp[(2) - (6)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHI, (yyvsp[(2) - (6)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHI, (yyvsp[(2) - (6)].stp)->stval.array) ;

	     CODE_FE_PUSHA()  ;

             (yyval.start) = (yyvsp[(3) - (6)].start) ;
           }
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 844 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ;  CODE_FE_PUSHA() ; }
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 846 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 850 "parse.y"
    { field_A2I(MAWK) ; }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 853 "parse.y"
    { code1(F_ASSIGN) ; }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 854 "parse.y"
    { code1(F_ADD_ASG) ; }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 855 "parse.y"
    { code1(F_SUB_ASG) ; }
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 856 "parse.y"
    { code1(F_MUL_ASG) ; }
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 857 "parse.y"
    { code1(F_DIV_ASG) ; }
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 858 "parse.y"
    { code1(F_MOD_ASG) ; }
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 859 "parse.y"
    { code1(F_POW_ASG) ; }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 866 "parse.y"
    { code2(MAWK, _BUILTIN, mawk_bi_split) ; }
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 870 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (5)].start) ;
              check_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
              mawk_code_array(MAWK, (yyvsp[(5) - (5)].stp))  ;
            }
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 877 "parse.y"
    { code2(MAWK, _PUSHI, &MAWK->fs_shadow) ; }
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 879 "parse.y"
    { 
                  if ( CDP((yyvsp[(2) - (3)].start)) == mawk_code_ptr - 2 )
                  {
                    if ( mawk_code_ptr[-2].op == _MATCH0 )
                        RE_as_arg(MAWK) ;
                    else
                    if ( mawk_code_ptr[-2].op == _PUSHS )
                    { mawk_cell_t *cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;

                      cp->type = C_STRING ;
                      cp->ptr = mawk_code_ptr[-1].ptr ;
                      mawk_cast_for_split(MAWK, cp) ;
                      mawk_code_ptr[-2].op = _PUSHC ;
                      mawk_code_ptr[-1].ptr = (PTR) cp ;
                    }
                  }
                }
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 903 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (6)].start) ; 
          code2(MAWK, _BUILTIN, mawk_bi_match) ;
        }
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 910 "parse.y"
    {
	       INST *p1 = CDP((yyvsp[(1) - (1)].start)) ;

               if ( p1 == mawk_code_ptr - 2 ) 
               {
                 if ( p1->op == _MATCH0 ) RE_as_arg(MAWK) ;
                 else
                 if ( p1->op == _PUSHS )
                 { mawk_cell_t *cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;

                   cp->type = C_STRING ;
                   cp->ptr = p1[1].ptr ;
                   mawk_cast_to_RE(MAWK, cp) ;
                   p1->op = _PUSHC ;
                   p1[1].ptr = (PTR) cp ;
                 } 
               }
             }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 933 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                      code1(_EXIT0) ; }
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 936 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; code1(_EXIT) ; }
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 939 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                      code1(_RET0) ; }
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 942 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; code1(_RET) ; }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 947 "parse.y"
    { (yyval.start) = mawk_code_offset ;
            code2(MAWK, F_PUSHA, &MAWK->field[0]) ;
            code1(_PUSHINT) ; code1(0) ; 
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            MAWK->getline_flag = 0 ;
          }
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 954 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ;
            code1(_PUSHINT) ; code1(0) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            MAWK->getline_flag = 0 ;
          }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 960 "parse.y"
    { code1(_PUSHINT) ; code1(F_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            /* getline_flag already off in yylex() */
          }
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 965 "parse.y"
    { code2(MAWK, F_PUSHA, &MAWK->field[0]) ;
            code1(_PUSHINT) ; code1(PIPE_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
          }
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 970 "parse.y"
    { 
            code1(_PUSHINT) ; code1(PIPE_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
          }
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 976 "parse.y"
    { MAWK->getline_flag = 1 ; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 983 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                   code2(MAWK, F_PUSHA, MAWK->field+0) ;
                 }
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 987 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 995 "parse.y"
    {
	     INST *p5 = CDP((yyvsp[(5) - (6)].start)) ;
	     INST *p6 = CDP((yyvsp[(6) - (6)].start)) ;

             if ( p6 - p5 == 2 && p5->op == _PUSHS  )
             { /* cast from STRING to REPL at compile time */
               mawk_cell_t *cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;
               cp->type = C_STRING ;
               cp->ptr = p5[1].ptr ;
               mawk_cast_to_REPL(MAWK, cp) ;
               p5->op = _PUSHC ;
               p5[1].ptr = (PTR) cp ;
             }
             code2(MAWK, _BUILTIN, (yyvsp[(1) - (6)].fp)) ;
             (yyval.start) = (yyvsp[(3) - (6)].start) ;
           }
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1013 "parse.y"
    { (yyval.fp) = mawk_bi_sub ; }
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1014 "parse.y"
    { (yyval.fp) = mawk_bi_gsub ; }
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1019 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                  code2(MAWK, F_PUSHA, &MAWK->field[0]) ; 
                }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1024 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1032 "parse.y"
    { 
		   resize_fblock(MAWK, (yyvsp[(1) - (2)].fbp)) ;
                   mawk_restore_ids(MAWK) ;
		   switch_code_to_main(MAWK) ;
                 }
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1040 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ;
                   MAWK->scope = SCOPE_FUNCT ;
                   MAWK->active_funct = (yyvsp[(1) - (4)].fbp) ;
                   *MAWK->main_code_p = MAWK->active_code ;

		   (yyvsp[(1) - (4)].fbp)->nargs = (yyvsp[(3) - (4)].ival) ;
                   if ( (yyvsp[(3) - (4)].ival) )
                        (yyvsp[(1) - (4)].fbp)->typev = (char *)
			memset( mawk_zmalloc(MAWK, (yyvsp[(3) - (4)].ival)), ST_LOCAL_NONE, (yyvsp[(3) - (4)].ival)) ;
                   else (yyvsp[(1) - (4)].fbp)->typev = (char *) 0 ;

		   mawk_code_ptr = mawk_code_base =
                       (INST *) mawk_zmalloc(MAWK, INST_BYTES(PAGESZ));
		   mawk_code_limit = mawk_code_base + PAGESZ ;
		   mawk_code_warn = mawk_code_limit - CODEWARN ;
                 }
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1059 "parse.y"
    { FBLOCK  *fbp ;

                   if ( (yyvsp[(2) - (2)].stp)->type == ST_NONE )
                   {
                         (yyvsp[(2) - (2)].stp)->type = ST_FUNCT ;
                         fbp = (yyvsp[(2) - (2)].stp)->stval.fbp = 
                             (FBLOCK *) mawk_zmalloc(MAWK, sizeof(FBLOCK)) ;
                         fbp->name = (yyvsp[(2) - (2)].stp)->name ;
			 fbp->code = (INST*) 0 ;
                   }
                   else
                   {
                         mawk_type_error(MAWK, (yyvsp[(2) - (2)].stp) ) ;

                         /* this FBLOCK will not be put in
                            the symbol table */
                         fbp = (FBLOCK*) mawk_zmalloc(MAWK, sizeof(FBLOCK)) ;
                         fbp->name = "" ;
                   }
                   (yyval.fbp) = fbp ;
                 }
    break;

  case 170:
/* Line 1787 of yacc.c  */
#line 1082 "parse.y"
    { (yyval.fbp) = (yyvsp[(2) - (2)].fbp) ; 
                   if ( (yyvsp[(2) - (2)].fbp)->code ) 
                       mawk_compile_error(MAWK, "redefinition of %s" , (yyvsp[(2) - (2)].fbp)->name) ;
                 }
    break;

  case 171:
/* Line 1787 of yacc.c  */
#line 1088 "parse.y"
    { (yyval.ival) = 0 ; }
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1093 "parse.y"
    { (yyvsp[(1) - (1)].stp) = mawk_save_id(MAWK, (yyvsp[(1) - (1)].stp)->name) ;
                (yyvsp[(1) - (1)].stp)->type = ST_LOCAL_NONE ;
                (yyvsp[(1) - (1)].stp)->offset = 0 ;
                (yyval.ival) = 1 ;
              }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1099 "parse.y"
    { if ( is_local((yyvsp[(3) - (3)].stp)) ) 
                  mawk_compile_error(MAWK, "%s is duplicated in argument list",
                    (yyvsp[(3) - (3)].stp)->name) ;
                else
                { (yyvsp[(3) - (3)].stp) = mawk_save_id(MAWK, (yyvsp[(3) - (3)].stp)->name) ;
                  (yyvsp[(3) - (3)].stp)->type = ST_LOCAL_NONE ;
                  (yyvsp[(3) - (3)].stp)->offset = (yyvsp[(1) - (3)].ival) ;
                  (yyval.ival) = (yyvsp[(1) - (3)].ival) + 1 ;
                }
              }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1112 "parse.y"
    {  /* we may have to recover from a bungled function
		       definition */
		   /* can have local ids, before code scope
		      changes  */
		    mawk_restore_ids(MAWK) ;

		    switch_code_to_main(MAWK) ;
		 }
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1124 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ;
             code2(MAWK, _CALL, (yyvsp[(1) - (3)].fbp)) ;

             if ( (yyvsp[(3) - (3)].ca_p) )  code1((yyvsp[(3) - (3)].ca_p)->arg_num+1) ;
             else  code1(0) ;
               
	     mawk_check_fcall(MAWK, (yyvsp[(1) - (3)].fbp), MAWK->scope, MAWK->ps.code_move_level, MAWK->active_funct, 
			 (yyvsp[(3) - (3)].ca_p), MAWK->token_lineno) ;
           }
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1136 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ;
             code2(MAWK, _CALL, (yyvsp[(1) - (3)].ptr)) ;

             if ( (yyvsp[(3) - (3)].ca_p) )  code1((yyvsp[(3) - (3)].ca_p)->arg_num+1) ;
             else  code1(0) ;
           }
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1145 "parse.y"
    { (yyval.ca_p) = (CA_REC *) 0 ; }
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1147 "parse.y"
    { (yyval.ca_p) = (yyvsp[(2) - (2)].ca_p) ;
                 (yyval.ca_p)->link = (yyvsp[(1) - (2)].ca_p) ;
                 (yyval.ca_p)->arg_num = (yyvsp[(1) - (2)].ca_p) ? (yyvsp[(1) - (2)].ca_p)->arg_num+1 : 0 ;
               }
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1162 "parse.y"
    { (yyval.ca_p) = (CA_REC *) 0 ; }
    break;

  case 181:
/* Line 1787 of yacc.c  */
#line 1164 "parse.y"
    { (yyval.ca_p) = MAWK_ZMALLOC(MAWK, CA_REC) ;
                (yyval.ca_p)->link = (yyvsp[(1) - (3)].ca_p) ;
                (yyval.ca_p)->type = CA_EXPR  ;
                (yyval.ca_p)->arg_num = (yyvsp[(1) - (3)].ca_p) ? (yyvsp[(1) - (3)].ca_p)->arg_num+1 : 0 ;
		(yyval.ca_p)->call_offset = mawk_code_offset ;
              }
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1171 "parse.y"
    { (yyval.ca_p) = MAWK_ZMALLOC(MAWK, CA_REC) ;
                (yyval.ca_p)->link = (yyvsp[(1) - (3)].ca_p) ;
                (yyval.ca_p)->arg_num = (yyvsp[(1) - (3)].ca_p) ? (yyvsp[(1) - (3)].ca_p)->arg_num+1 : 0 ;

                mawk_code_call_id(MAWK, (yyval.ca_p), (yyvsp[(2) - (3)].stp)) ;
              }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1180 "parse.y"
    { (yyval.ca_p) = MAWK_ZMALLOC(MAWK, CA_REC) ;
                (yyval.ca_p)->type = CA_EXPR ;
		(yyval.ca_p)->call_offset = mawk_code_offset ;
              }
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1186 "parse.y"
    { (yyval.ca_p) = MAWK_ZMALLOC(MAWK, CA_REC) ;
                mawk_code_call_id(MAWK, (yyval.ca_p), (yyvsp[(1) - (2)].stp)) ;
              }
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1193 "parse.y"
    { mawk_parser_include(MAWK, (yyvsp[(2) - (3)].ptr)); }
    break;


/* Line 1787 of yacc.c  */
#line 3511 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (MAWK, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (MAWK, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, MAWK);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, MAWK);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (MAWK, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, MAWK);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, MAWK);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 1196 "parse.y"


/* resize the code for a user function */

static void  resize_fblock(mawk_state_t *MAWK, FBLOCK *fbp)
{
  CODEBLOCK *p = MAWK_ZMALLOC(MAWK, CODEBLOCK) ;
  unsigned dummy ;

  mawk_code2op(MAWK, _RET0, _HALT) ;
	/* make sure there is always a return */

  *p = MAWK->active_code ;
  fbp->code = mawk_code_shrink(MAWK, p, &dummy) ;
      /* mawk_code_shrink() zfrees p */

  if ( MAWK->dump_code_flag ) mawk_add_to_fdump_list(MAWK, fbp) ;
}


/* convert FE_PUSHA  to  FE_PUSHI
   or F_PUSH to F_PUSHI
*/
static void  field_A2I(mawk_state_t *MAWK)
{
	mawk_cell_t *cp;

  if ( mawk_code_ptr[-1].op == FE_PUSHA &&
       mawk_code_ptr[-1].ptr == (PTR) 0)
  /* On most architectures, the two mawk_tests are the same; a good
     compiler might eliminate one.  On LM_DOS, and possibly other
     segmented architectures, they are not */
  { mawk_code_ptr[-1].op = FE_PUSHI ; }
  else
  {
    cp = (mawk_cell_t *) mawk_code_ptr[-1].ptr ;

    if (cp == MAWK->field  || (cp > MAWK_NF && cp <= LAST_PFIELD))
    {
         mawk_code_ptr[-2].op = _PUSHI  ;
    }
    else if ( cp == MAWK_NF )
    { mawk_code_ptr[-2].op = NF_PUSHI ; mawk_code_ptr-- ; }

    else
    { 
      mawk_code_ptr[-2].op = F_PUSHI ;
      mawk_code_ptr -> op = mawk_field_addr_to_index(MAWK, mawk_code_ptr[-1].ptr ) ;
      mawk_code_ptr++ ;
    }
  }
}

/* we've seen an ID in a context where it should be a VAR,
   check that's consistent with previous usage */
static void check_var(mawk_state_t *MAWK, register SYMTAB *p)
{
      switch(p->type)
      {
        case ST_NONE : /* new id */
            p->type = ST_VAR ;
            p->stval.cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;
            p->stval.cp->type = C_NOINIT ;
            break ;

        case ST_LOCAL_NONE :
            p->type = ST_LOCAL_VAR ;
            MAWK->active_funct->typev[p->offset] = ST_LOCAL_VAR ;
            break ;

        case ST_VAR :
        case ST_LOCAL_VAR :  break ;

        default :
            mawk_type_error(MAWK, p) ;
            break ;
      }
}

/* we've seen an ID in a context where it should be an ARRAY,
   check that's consistent with previous usage */
static  void  check_array(mawk_state_t *MAWK, register SYMTAB *p)
{
      switch(p->type)
      {
        case ST_NONE :  /* a new array */
            p->type = ST_ARRAY ;
            p->stval.array = mawk_array_new(MAWK, NULL) ;
            break ;

        case  ST_ARRAY :
        case  ST_LOCAL_ARRAY :
            break ;

        case  ST_LOCAL_NONE  :
            p->type = ST_LOCAL_ARRAY ;
            MAWK->active_funct->typev[p->offset] = ST_LOCAL_ARRAY ;
            break ;

        default : mawk_type_error(MAWK, p) ; break ;
      }
}

static void mawk_code_array(mawk_state_t *MAWK, register SYMTAB *p)
{
  if ( is_local(p) ) mawk_code2op(MAWK, LA_PUSHA, p->offset) ; 
  else  code2(MAWK, A_PUSHA, p->stval.array) ;
}


/* we've seen an ID as an argument to a user defined function */
static void mawk_code_call_id(mawk_state_t *MAWK, register CA_REC *p, register SYMTAB *ip)
{
  p->call_offset = mawk_code_offset ;
     /* This always get set now.  So that fcall:relocate_arglist
	works. */

  switch( ip->type )
  {
    case  ST_VAR  :
            p->type = CA_EXPR ;
            code2(MAWK, _PUSHI, ip->stval.cp) ;
            break ;

    case  ST_LOCAL_VAR  :
            p->type = CA_EXPR ;
            mawk_code2op(MAWK, L_PUSHI, ip->offset) ;
            break ;

    case  ST_ARRAY  :
            p->type = CA_ARRAY ;
            code2(MAWK, A_PUSHA, ip->stval.array) ;
            break ;

    case  ST_LOCAL_ARRAY :
            p->type = CA_ARRAY ;
            mawk_code2op(MAWK, LA_PUSHA, ip->offset) ;
            break ;

    /* not enough info to code it now; it will have to
       be patched later */

    case  ST_NONE :
            p->type = ST_NONE ;
            p->sym_p = ip ;
            code2(MAWK, _PUSHI, &MAWK->code_call_id_dummy) ;
            break ;

    case  ST_LOCAL_NONE :
            p->type = ST_LOCAL_NONE ;
            p->type_p = & MAWK->active_funct->typev[ip->offset] ;
            mawk_code2op(MAWK, L_PUSHI, ip->offset) ;
            break ;

#ifdef   DEBUG
    default :
            mawk_bozo(MAWK, "mawk_code_call_id") ;
#endif

  }
}

/* an RE by itself was coded as _MATCH0 , change to
   push as an expression */

static void RE_as_arg(mawk_state_t *MAWK)
{
	mawk_cell_t *cp = MAWK_ZMALLOC(MAWK, mawk_cell_t) ;

  mawk_code_ptr -= 2 ;
  cp->type = C_RE ;
  cp->ptr = mawk_code_ptr[1].ptr ;
  code2(MAWK, _PUSHC, cp) ;
}

/* reset the active_code back to the MAIN block */
static void switch_code_to_main(mawk_state_t *MAWK)
{
   switch(MAWK->scope)
   {
     case SCOPE_BEGIN :
	*MAWK->begin_code_p = MAWK->active_code ;
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_END :
	*MAWK->end_code_p = MAWK->active_code ;
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_FUNCT :
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_MAIN :
	break ;
   }
   MAWK->active_funct = (FBLOCK*) 0 ;
   MAWK->scope = SCOPE_MAIN ;
}


void mawk_parse(mawk_state_t *MAWK)
{
	if (!MAWK->binary_loaded) {
   if ( yyparse(MAWK) || MAWK->compile_error_count != 0 ) mawk_exit(MAWK, 2) ;

   mawk_scan_cleanup(MAWK) ;
   mawk_set_code(MAWK) ;
   /* code must be set before call to mawk_resolve_fcalls() */
   if ( MAWK->resolve_list )  mawk_resolve_fcalls(MAWK) ;
	}

   if ( MAWK->compile_error_count != 0 ) mawk_exit(MAWK, 2) ;
   if ( MAWK->dump_code_flag ) { mawk_dump_code(MAWK);}
   if ( MAWK->dump_sym_flag ) { mawk_dump_sym_text(MAWK); }
   if ((MAWK->dump_code_flag ) || ( MAWK->dump_sym_flag )) { mawk_exit(MAWK, 0); }
}


void mawk_parser_include(mawk_state_t *MAWK, void *str)
{
	mawk_parser_push(MAWK);

	MAWK->ps.eof_flag = 0 ;
	MAWK->ps.pfile_name = ((mawk_string_t *)str)->str;
	MAWK->ps.buffp = MAWK->ps.buffer = (unsigned char *) mawk_zmalloc(MAWK, BUFFSZ + 1) ;
	*MAWK->ps.buffp = '\0';
	if (mawk_scan_open(MAWK) == 1)
		MAWK->token_lineno = MAWK->lineno = 1 ;
	else
		mawk_parser_pop(MAWK);
}
